Package: eAnalytics
Version: 0.4
Title: Dynamic Web-Based Analytics for the Energy Industry
Description: A 'Shiny' web application for energy industry analytics.
      Take an overview of the industry, measure Key Performance Indicators,
      identify changes in the industry over time, and discover new relationships in the data.
URL: http://paulgovan.github.io/eAnalytics/,
        https://github.com/paulgovan/eAnalytics
BugReports: https://github.com/paulgovan/eAnalytics/issues
Authors@R: person("Paul", "Govan", email = "paul.govan2@gmail.com", role = c("aut", "cre", "cph"), comment = c(ORCID = "0000-0002-1821-8492"))
Depends: R (>= 2.10.0),
License: Apache License
Imports: dplyr, DT, energyr, googleVis, leaflet, plotly (>= 4.5.2),
        shiny, shinydashboard, shinyWidgets
Encoding: UTF-8
RoxygenNote: 7.3.3
Suggests: knitr, rmarkdown, shinytest2, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-05-19 20:22:26 UTC; paulgovan
Author: Paul Govan [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-1821-8492>)
Maintainer: Paul Govan <paul.govan2@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-19 20:40:02 UTC
Built: R 4.5.2; ; 2026-05-19 21:09:16 UTC; unix

Package: eAnalytics
Version: 0.4
Title: Dynamic Web-Based Analytics for the Energy Industry
Description: A 'Shiny' web application for energy industry analytics.
      Take an overview of the industry, measure Key Performance Indicators,
      identify changes in the industry over time, and discover new relationships in the data.
URL: http://paulgovan.github.io/eAnalytics/,
        https://github.com/paulgovan/eAnalytics
BugReports: https://github.com/paulgovan/eAnalytics/issues
Authors@R: person("Paul", "Govan", email = "paul.govan2@gmail.com", role = c("aut", "cre", "cph"), comment = c(ORCID = "0000-0002-1821-8492"))
Depends: R (>= 2.10.0),
License: Apache License
Imports: dplyr, DT, energyr, googleVis, leaflet, plotly (>= 4.5.2),
        shiny, shinydashboard, shinyWidgets
Encoding: UTF-8
RoxygenNote: 7.3.3
Suggests: knitr, rmarkdown, shinytest2, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-05-19 20:22:26 UTC; paulgovan
Author: Paul Govan [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-1821-8492>)
Maintainer: Paul Govan <paul.govan2@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-19 20:40:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# eAnalytics <a href="http://paulgovan.github.io/eAnalytics/"><img src="man/figures/logo.png" align="right" height="139" alt="eAnalytics website" /></a>

<!-- badges: start -->

[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![CRAN
status](https://www.r-pkg.org/badges/version/eAnalytics)](https://CRAN.R-project.org/package=eAnalytics)
[![R-CMD-check](https://github.com/paulgovan/eAnalytics/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/paulgovan/eAnalytics/actions/workflows/R-CMD-check.yaml)
[![](http://cranlogs.r-pkg.org/badges/grand-total/eAnalytics)](https://cran.r-project.org/package=eAnalytics)
[![](http://cranlogs.r-pkg.org/badges/last-month/eAnalytics)](https://cran.r-project.org/package=eAnalytics)
[![](https://img.shields.io/badge/doi-10.5334/jors.144-green.svg)](https://doi.org/10.5334/jors.144)
<!-- badges: end -->

## Features

- Profile: take an overview of the industry
- Performance: measure key performance indicators (KPIs)
- Trends: identify changes in the industry over time
- Explorer: discover new relationships in the data

## Overview

`eAnalytics` is a [shiny](https://shiny.posit.co/) web application built
on top of [R](https://www.r-project.org) for energy analytics. To learn
more about this project, check out this
[article](https://doi.org/10.5334/jors.144).

## Getting Started

To install `eAnalytics` in R:

``` r
install.packages("eAnalytics")
```

Or to install the latest development version:

``` r
devtools::install_github("paulgovan/eAnalytics")
```

To launch the app:

``` r
eAnalytics::eAnalytics()
```

Or to access the app through a browser, visit
[paulgovan.shinyapps.io/eAnalytics](https://paulgovan.shinyapps.io/eAnalytics/).

## Data

`eAnalytics` is built on the
[energyr](https://github.com/paulgovan/energyr) R package of data
published by the United States Federal Energy Regulatory Commission
[www.ferc.gov](https://www.ferc.gov). `energyr` contains several
datasets for different industry segments:

- `electric`: Electric Company Financial Data
- `gas`: Natural Gas Company Financial Data
- `hydropower`: Hydropower Plant Data
- `lng`: LNG Plant Data
- `oil`: Oil Company Financial Data
- `pipeline`: Natural Gas Pipeline Project Data
- `storage`: Natural Gas Storage Field Data

## Code of Conduct

Please note that the eAnalytics project is released with a [Contributor
Code of
Conduct](http://paulgovan.github.io/eAnalytics/CODE_OF_CONDUCT.html). By
contributing to this project, you agree to abide by its terms.

# Load data from 'energyr' package
data(electric, package = "energyr")
data(hydropower, package = "energyr")
data(gas, package = "energyr")
data(oil, package = "energyr")
data(storage, package = "energyr")
data(pipeline, package = "energyr")
data(lng, package = "energyr")

# Aggregate pipeline data for googleVis chart
motionData <- dplyr::select(pipeline, Type, Year, Cost, Miles, Capacity)
motionData <- dplyr::filter(motionData,!is.na(Year))
motionData[is.na(motionData)] <- 0
motionData <- aggregate(
  motionData[, 3:5],
  by = list(Year = motionData$Year, Type = motionData$Type),
  FUN = sum
)
motionData$Year <- as.Date(as.character(motionData$Year), format = "%Y")

# Aggregate electric data for googleVis motion chart
elecMotionData <- dplyr::select(electric, Company, Year, Revenue, Bill)
elecMotionData <- dplyr::filter(elecMotionData, !is.na(Year))
elecMotionData <- aggregate(
  elecMotionData[, c("Revenue", "Bill")],
  by = list(Year = elecMotionData$Year, Company = elecMotionData$Company),
  FUN = sum
)
elecMotionData$Year <- as.Date(as.character(elecMotionData$Year), format = "%Y")

# Aggregate oil data for googleVis motion chart
oilMotionData <- dplyr::select(oil, Company, Year, Revenue, Bill)
oilMotionData <- dplyr::filter(oilMotionData, !is.na(Year))
oilMotionData <- aggregate(
  oilMotionData[, c("Revenue", "Bill")],
  by = list(Year = oilMotionData$Year, Company = oilMotionData$Company),
  FUN = sum
)
oilMotionData$Year <- as.Date(as.character(oilMotionData$Year), format = "%Y")

# Calculate the number of unique companies, projects, and facilities in database
company <- length(unique(electric[, "Company"])) + length(unique(hydropower[, "Company"])) + length(unique(gas[, "Company"])) + length(unique(storage[, "Company"])) + length(unique(lng[, "Company"])) + length(unique(oil[, "Company"]))
project <- length(unique(pipeline[, "Name"]))
facility <- length(unique(hydropower[, "Name"])) + length(unique(storage[, "Field"])) + length(unique(lng[, "Company"]))

# Define a server for the app
shiny::shinyServer(function(input, output, session) {

  # Create the projects box
  output$projectBox <- shiny::renderUI({
    shinydashboard::valueBox(
      project,
      "Projects in Database",
      icon = shiny::icon("database"),
      color = "green"
    )
  })

  # Create the companies box
  output$companyBox <- shiny::renderUI({
    shinydashboard::valueBox(company,
                             "Company Profiles",
                             icon = shiny::icon("users"),
                             color = "purple")
  })

  # Create the facilities box
  output$facilityBox <- shiny::renderUI({
    shinydashboard::valueBox(
      facility,
      "Facility Profiles",
      icon = shiny::icon("building"),
      color = "yellow"
    )
  })

  # Plot the electric rates line chart
  output$lineChart1 <- plotly::renderPlotly({

    # Get the curently selected table rows from the user
    s1 <- input$elecTable_rows_all

    # Subset data based on user selection
    if (length(s1) > 0 && length(s1) < nrow(electric)) {
      elec_data <- electric[s1, ]
    } else {
      elec_data <- electric
    }

    # Apply company filter if selected
    if (!is.null(input$elecCompany) && length(input$elecCompany) > 0) {
      elec_data <- elec_data[elec_data$Company %in% input$elecCompany, ]
    }

    # Get the rate variable from the user
    if (input$elec == "Revenue") {
      Rate <- elec_data$Revenue
    } else {
      Rate <- elec_data$Bill
    }

    # Plot the line chart
    plotly::plot_ly(elec_data,
                    x = ~Year,
                    y = ~Rate,
                    split = ~Company,
                    type = "scatter") %>%

      # Add style options
      layout(
        updatemenus = list(
          list(
            buttons = list(

              list(method = "restyle",
                   args = list("mode", "lines"),
                   label = "Lines"),

              list(method = "restyle",
                   args = list("mode", "lines+markers"),
                   label = "Lines + Markers"),

              list(method = "restyle",
                   args = list("mode", "markers"),
                   label = "Markers")))
        ))
  })

  # Show electric rates table
  output$elecTable <- DT::renderDataTable({

    DT::datatable(
      electric,
      rownames = FALSE,
      extensions = 'Buttons',
      options = list(
        searchHighlight = TRUE,
        order = list(list(3, 'desc')),
        dom = 'Bfrtip',
        buttons = c('copy', 'csv', 'excel', 'pdf', 'print')
      )
    ) %>%
      DT::formatCurrency(c('Revenue', 'Bill'))
  }, server = FALSE)

  # Plot the hydropower map
  output$map1 <- leaflet::renderLeaflet({

    # Get the curently selected table rows from the user
    s1 <- input$hydroTable_rows_all

    # Subset data based on user selection
    if (length(s1) > 0 && length(s1) < nrow(hydropower)) {
      hydro_data <- hydropower[s1, ]
    } else {
      hydro_data <- hydropower
    }

    # Get complete cases from hydropower data
    hydro_data <- hydro_data[complete.cases(hydro_data), ]

    # Create the popup content
    content <- paste0(
      "<strong>Name: </strong>",
      hydro_data$Name,
      "<br><strong>Company: </strong>",
      hydro_data$Company,
      "<br><strong>Waterway: </strong>",
      hydro_data$Waterway,
      "<br><strong>Capacity (KW): </strong>",
      hydro_data$Capacity
    )

    # Create the color palette
    pal <- leaflet::colorFactor(c("navy", "red"), domain = c("Expired", "Active"))

    # Create the leaflet map
    leaflet::leaflet(hydro_data) %>%

      # Manually adjust the bounds of the map
      leaflet::fitBounds(-125, 49,-62, 18) %>%

      # Add provider tiles to the map
      leaflet::addProviderTiles("Esri.WorldStreetMap", group = "World Street Map") %>%
      leaflet::addProviderTiles("CartoDB.DarkMatter", group = "Dark Matter") %>%
      leaflet::addProviderTiles("Esri.WorldImagery", group = "World Imagery") %>%

      # Add circle markers to the map
      leaflet::addCircles(
        radius = ~ sqrt(Capacity / 1000),
        color = ~ pal(Status),
        popup = ~ content
      ) %>%

      # Add a legend to the map
      leaflet::addLegend(
        "topright",
        pal = pal,
        values = ~ Status,
        title = "Status"
      ) %>%

      # Add a control widget to the map
      leaflet::addLayersControl(
        baseGroups = c("World Street Map", "Dark Matter", "World Imagery"),
        position = "bottomright",
        options = leaflet::layersControlOptions(collapsed = TRUE)
      )
  })

  # Plot the hydropower histogram
  output$hist1 <- plotly::renderPlotly({

    # Get the curently selected table rows from the user
    s1 <- input$hydroTable_rows_all

    # Subset data based on user selection
    if (length(s1) > 0 && length(s1) < nrow(hydropower)) {
      hydro_data <- hydropower[s1, ]
    } else {
      hydro_data <- hydropower
    }

    # Get the complete cases from hydropower data
    hydro_data <- hydro_data[complete.cases(hydro_data), ]

    # Convert capacity variable
    Capacity <- hydro_data$Capacity / 1000

    # Plot the histogram
    plotly::plot_ly(x = ~Capacity,
                    type = "histogram",
                    opacity = 0.75) %>%
      layout(autosize = F,
             width = 300,
             height = 250)
  })

  # Show hydropower data table
  output$hydroTable <- DT::renderDataTable({

    DT::datatable(
      hydropower[, c("Number", "Name", "Expiration", "Issued", "Status", "Capacity", "Company", "Waterway", "State")],
      rownames = FALSE,
      colnames = c('Capacity (KW)' = 'Capacity'),
      extensions = c('Responsive', 'Buttons'),
      options = list(
        searchHighlight = TRUE,
        dom = 'Bfrtip',
        buttons = c('copy', 'csv', 'excel', 'pdf', 'print')
      )
    )
  })

  # Plot the storage map
  output$map2 <- leaflet::renderLeaflet({

    # Get the complete cases from storage data
    stor_data <- storage[complete.cases(storage), ]

    # Create the popup content
    content <- paste0(
      "<strong>Company: </strong>",
      stor_data$Company,
      "<br><strong>Field: </strong>",
      stor_data$Field,
      "<br><strong>Total Capacity (BCF): </strong>",
      stor_data$Total
    )

    # Create the color palette
    pal <- leaflet::colorFactor(c("navy", "red", "green"),
                           domain = c("Depleted Field", "Salt Dome", "Aquifer"))

    # Plot the leaflet map based on 'Total Capacity' variable
    if (input$storageSize == "Total") {

      leaflet::leaflet(stor_data) %>%

        # Add provider tiles to the map
        leaflet::addProviderTiles("Esri.WorldStreetMap", group = "World Street Map") %>%
        leaflet::addProviderTiles("CartoDB.DarkMatter", group = "Dark Matter") %>%
        leaflet::addProviderTiles("Esri.WorldImagery", group = "World Imagery") %>%

        # Add circle markers to the map
        leaflet::addCircles(
          radius = ~ Total / 1000,
          color = ~ pal(Type),
          popup = ~ content
        ) %>%

        # Add a control widget to the map
        leaflet::addLayersControl(
          baseGroups = c("World Street Map", "Dark Matter", "World Imagery"),
          position = "bottomright",
          options = leaflet::layersControlOptions(collapsed = TRUE)
        ) %>%

        # Add a legend to the map
        leaflet::addLegend(
          "topright",
          pal = pal,
          values = ~ Type,
          title = "Storage Type"
        )

      # Plot the leaflet map based on 'Working Capacity' variable
    } else if (input$storageSize == "Working") {

      leaflet::leaflet(stor_data) %>%

        # Add provider tiles to the map
        leaflet::addProviderTiles("Esri.WorldStreetMap", group = "World Street Map") %>%
        leaflet::addProviderTiles("CartoDB.DarkMatter", group = "Dark Matter") %>%
        leaflet::addProviderTiles("Esri.WorldImagery", group = "World Imagery") %>%

        # Add circle markers to the map
        leaflet::addCircles(
          radius = ~ Working / 1000,
          color = ~ pal(Type),
          popup = ~ content
        ) %>%

        # Add a control widget to the map
        leaflet::addLayersControl(
          baseGroups = c("World Street Map", "Dark Matter", "World Imagery"),
          position = "bottomright",
          options = leaflet::layersControlOptions(collapsed = TRUE)
        ) %>%

        # Add a legend to the map
        leaflet::addLegend(
          "topright",
          pal = pal,
          values = ~ Type,
          title = "Storage Type"
        )
    }
  })

  # Plot the storage histogram
  output$hist2 <- plotly::renderPlotly({

    # Get the complete cases from storage data
    stor_data <- storage[complete.cases(storage), ]

    # Get the selected variable from the user
    if (input$storageSize == "Total") {
      Capacity <- stor_data$Total / 1000
    } else if (input$storageSize == "Working") {
      Capacity <- stor_data$Working / 1000
    }

    # Plot the histogram
    plotly::plot_ly(x = ~Capacity,
                    type = "histogram",
                    opacity = 0.75) %>%
      layout(autosize = F,
             width = 300,
             height = 250)
  })

  # Plot the LNG map
  output$map3 <- leaflet::renderLeaflet({

    # Get the complete cases from lng data
    lng_data <- lng[complete.cases(lng), ]

    # Create the popup content
    content <- paste0(
      "<strong>Company: </strong>",
      lng_data$Company,
      "<br><strong>Capacity (BCFD): </strong>",
      lng_data$Capacity
    )

    # Create the leaflet map based on 'type' variable
    if (input$lngColor == "type") {

      # Create the color palette
      pal <- leaflet::colorFactor(c("navy", "red"), domain = c("Export", "Import"))

      leaflet::leaflet(lng_data) %>%

        # Add provider tiles to the map
        leaflet::addProviderTiles("Esri.WorldStreetMap", group = "World Street Map") %>%
        leaflet::addProviderTiles("CartoDB.DarkMatter", group = "Dark Matter") %>%
        leaflet::addProviderTiles("Esri.WorldImagery", group = "World Imagery") %>%

        # Add circle markers to the map
        leaflet::addCircles(
          radius = ~ Capacity,
          color = ~ pal(Type),
          popup = ~ content
        ) %>%

        # Add a legend to the map
        leaflet::addLegend(
          "topright",
          pal = pal,
          values = ~ Type,
          title = "Facility Type"
        ) %>%

        # Add a control widget to the map
        leaflet::addLayersControl(
          baseGroups = c("World Street Map", "Dark Matter", "World Imagery"),
          position = "bottomright",
          options = leaflet::layersControlOptions(collapsed = TRUE)
        )

      # Create the leaflet map based on 'status' variable
    } else if (input$lngColor == "status") {

      # Create the color palette
      pal <- leaflet::colorFactor(c("navy", "red", "green", "orange"),
          domain = c(
            "Not under construction",
            "Under construction",
            "Existing",
            "Proposed"
          )
        )

      leaflet::leaflet(lng_data) %>%

        # Add provider tiles to the map
        leaflet::addProviderTiles("Esri.WorldStreetMap", group = "World Street Map") %>%
        leaflet::addProviderTiles("CartoDB.DarkMatter", group = "Dark Matter") %>%
        leaflet::addProviderTiles("Esri.WorldImagery", group = "World Imagery") %>%

        # Add circle markers to the map
        leaflet::addCircles(
          radius = ~ Capacity,
          color = ~ pal(Status),
          popup = ~ content
        ) %>%

        # Add a legend to the map
        leaflet::addLegend(
          "topright",
          pal = pal,
          values = ~ Status,
          title = "Facility Status"
        ) %>%

        # Add a control widget to the map
        leaflet::addLayersControl(
          baseGroups = c("World Street Map", "Dark Matter", "World Imagery"),
          position = "bottomright",
          options = leaflet::layersControlOptions(collapsed = TRUE)
        )
    }
  })

  # Plot the LNG capacity histogram
  output$hist3 <- plotly::renderPlotly({

    # Get the complete cases from lng data
    lng_data <- lng[complete.cases(lng), ]

    # Get the selected variable from the user
    Capacity <- lng_data$Capacity

    # Plot the histogram
    plotly::plot_ly(x = ~Capacity,
                    type = "histogram",
                    opacity = 0.75) %>%
      layout(autosize = F,
             width = 300,
             height = 250)
  })

  # Plot the natural gas pipeline histogram
  output$hist5 <- plotly::renderPlotly({

    # Get the selected variable from the user
    if (input$perform == "costMile") {
      Cost <- pipeline[, "Cost"] / pipeline[, "Miles"]
    } else if (input$perform == "costCap") {
      Cost <- pipeline[, "Cost"] / pipeline[, "Capacity"]
    }

    # Plot the histogram
    plotly::plot_ly(
      x = ~Cost,
      type = "histogram",
      opacity = 0.75,
      nbinx = 10
    )
  })

  # Draw a natural gas pipeline heatmap
  output$heatmap <- plotly::renderPlotly({

    # Subset data to get numeric variables
    pipe_data <- subset(pipeline, select = c("Cost", "Miles", "Capacity"))

    # Get correlation matrix
    dfcor <- cor(pipe_data, use = "complete.obs")

    # Get covariance matrix
    dfvar <- dfcor ^ 2 * 100

    # Get the type of heatmap from the user
    if (input$sensitivity == "varr") {
      df <- dfvar
    } else if (input$sensitivity == "corr") {
      df <- dfcor
    }

    # Plot the heatmap
    plotly::plot_ly(
      x = c("Cost", "Miles", "Capacity"),
      y = c("Cost", "Miles", "Capacity"),
      z = df,
      colorscale = "Greys",
      type = "heatmap"
    )
  })

  # Plot the natural gas cost boxplot
  output$boxplot <- plotly::renderPlotly({

    # Omit missing data
    pipe_data <- na.omit(pipeline)

    # Get selected variable from the user
    if (input$gas == "cost") {
      cost <- data.frame(Year = pipe_data[, "Year"], Cost = pipe_data[, "Cost"])
    } else if (input$gas == "costMile") {
      cost <- data.frame(Year = pipe_data[, "Year"], Cost = pipe_data[, "Cost"] / pipe_data[, "Miles"])
    } else if (input$gas == "costCap") {
      cost <- data.frame(Year = pipe_data[, "Year"], Cost = pipe_data[, "Cost"] / pipe_data[, "Capacity"])
    }

    # Plot the boxplot
    plotly::plot_ly(cost,
                    y = ~Cost,
                    split = ~Year,
                    type = "box")
  })

  # Plot the natural gas rates line chart
  output$lineChart3 <- plotly::renderPlotly({

    # Get the currently selected table rows from the user
    s2 <- input$gasTable_rows_all

    # Subset data based on user selection
    if (length(s2) > 0 && length(s2) < nrow(gas)) {
      gas_data <- gas[s2, ]
    } else {
      gas_data <- gas
    }

    # Apply company filter if selected
    if (!is.null(input$gasCompany) && length(input$gasCompany) > 0) {
      gas_data <- gas_data[gas_data$Company %in% input$gasCompany, ]
    }

    # Get the selected variable from the user
    if (input$gasRates == "Revenue") {
      Rate <- gas_data$Revenue
    } else {
      Rate <- gas_data$Bill
    }

    # Plot the line chart
    plotly::plot_ly(gas_data,
                    x = ~Year,
                    y = ~Rate,
                    split = ~Company,
                    type = "scatter") %>%

      # Add style options
      layout(
        updatemenus = list(
          list(
            buttons = list(

              list(method = "restyle",
                   args = list("mode", "lines"),
                   label = "Lines"),

              list(method = "restyle",
                   args = list("mode", "lines+markers"),
                   label = "Lines + Markers"),

              list(method = "restyle",
                   args = list("mode", "markers"),
                   label = "Markers")))
        ))

  })

  # Plot the natural gas pipeline motion chart
  output$motion1 <- googleVis::renderGvis({
    googleVis::gvisMotionChart(motionData, idvar = "Type",
                               timevar = "Year")
  })

  # Show natural gas pipeline table
  output$pipelineTable <- DT::renderDataTable({

    pipe_data <- pipeline[, !(names(pipeline) %in% 'Year')]

    DT::datatable(
      pipe_data[, ],
      rownames = FALSE,
      colnames = c(
        'Cost ($MM)' = 'Cost',
        'Capacity (MMcf/d)' = 'Capacity',
        'Diameter (IN)' = 'Diameter'
      ),
      extensions = c('Responsive', 'Buttons'),
      options = list(
        searchHighlight = TRUE,
        dom = 'Bfrtip',
        buttons = c('copy', 'csv', 'excel', 'pdf', 'print')
      )
    )
  })

  # Show natural gas rates table
  output$gasTable <- DT::renderDataTable({

    DT::datatable(
      gas,
      rownames = FALSE,
      extensions = 'Buttons',
      options = list(
        searchHighlight = TRUE,
        order = list(list(3, 'desc')),
        dom = 'Bfrtip',
        buttons = c('copy', 'csv', 'excel', 'pdf', 'print')
      )
    ) %>%
      DT::formatCurrency(c('Revenue', 'Bill'))
  }, server = FALSE)

  # Plot the oil rates line chart
  output$lineChart4 <- plotly::renderPlotly({

    # Get the currently selected table rows from the user
    s3 <- input$oilTable_rows_all

    # Subset data based on user selection
    if (length(s3) > 0 && length(s3) < nrow(oil)) {
      oil_data <- oil[s3, ]
    } else {
      oil_data <- oil
    }

    # Apply company filter if selected
    if (!is.null(input$oilCompany) && length(input$oilCompany) > 0) {
      oil_data <- oil_data[oil_data$Company %in% input$oilCompany, ]
    }

    # Get the type of variable from the user
    if (input$oil == "Revenue") {
      Rate <- oil_data$Revenue
    } else {
      Rate <- oil_data$Bill
    }

    # Plot the line chart
    plotly::plot_ly(oil_data,
                    x = ~Year,
                    y = ~Rate,
                    split = ~Company,
                    type = "scatter") %>%

      # Add style options
      layout(
        updatemenus = list(
          list(
            buttons = list(

              list(method = "restyle",
                   args = list("mode", "lines"),
                   label = "Lines"),

              list(method = "restyle",
                   args = list("mode", "lines+markers"),
                   label = "Lines + Markers"),

              list(method = "restyle",
                   args = list("mode", "markers"),
                   label = "Markers")))
        ))
  })

  # Show oil rates table
  output$oilTable <- DT::renderDataTable({

    DT::datatable(
      oil,
      rownames = FALSE,
      extensions = 'Buttons',
      options = list(
        searchHighlight = TRUE,
        order = list(list(3, 'desc')),
        dom = 'Bfrtip',
        buttons = c('copy', 'csv', 'excel', 'pdf', 'print')
      )
    ) %>%
      DT::formatCurrency(c('Revenue', 'Bill'))
  }, server = FALSE)

  # Populate company filter selectize inputs on session start
  shiny::updateSelectizeInput(session, "elecCompany",
    choices = sort(unique(electric$Company)), server = TRUE)
  shiny::updateSelectizeInput(session, "gasCompany",
    choices = sort(unique(gas$Company)), server = TRUE)
  shiny::updateSelectizeInput(session, "oilCompany",
    choices = sort(unique(oil$Company)), server = TRUE)

  # Home page summary bar chart
  output$homeChart <- plotly::renderPlotly({
    industry_counts <- data.frame(
      Industry = c("Electric", "Hydropower", "Natural Gas", "Storage", "LNG", "Oil"),
      Companies = c(
        length(unique(electric$Company)),
        length(unique(hydropower$Company)),
        length(unique(gas$Company)),
        length(unique(storage$Company)),
        length(unique(lng$Company)),
        length(unique(oil$Company))
      )
    )
    plotly::plot_ly(industry_counts,
                    x = ~Industry,
                    y = ~Companies,
                    type = "bar",
                    marker = list(color = "steelblue")) %>%
      plotly::layout(yaxis = list(title = "Number of Companies"))
  })

  # Plot the electric performance histogram
  output$elecHist <- plotly::renderPlotly({
    if (input$elecPerform == "Revenue") {
      Value <- electric$Revenue
    } else {
      Value <- electric$Bill
    }
    plotly::plot_ly(x = ~Value, type = "histogram", opacity = 0.75) %>%
      plotly::layout(xaxis = list(title = input$elecPerform))
  })

  # Draw the electric heatmap
  output$elecHeatmap <- plotly::renderPlotly({
    elec_num <- subset(electric, select = c("Revenue", "Bill", "Year"))
    dfcor <- cor(elec_num, use = "complete.obs")
    dfvar <- dfcor ^ 2 * 100
    if (input$elecSensitivity == "varr") {
      df <- dfvar
    } else {
      df <- dfcor
    }
    plotly::plot_ly(
      x = c("Revenue", "Bill", "Year"),
      y = c("Revenue", "Bill", "Year"),
      z = df,
      colorscale = "Greys",
      type = "heatmap"
    )
  })

  # Plot the electric explorer motion chart
  output$elecMotion <- googleVis::renderGvis({
    googleVis::gvisMotionChart(elecMotionData, idvar = "Company", timevar = "Year")
  })

  # Plot the oil performance histogram
  output$oilHist <- plotly::renderPlotly({
    if (input$oilPerform == "Revenue") {
      Value <- oil$Revenue
    } else {
      Value <- oil$Bill
    }
    plotly::plot_ly(x = ~Value, type = "histogram", opacity = 0.75) %>%
      plotly::layout(xaxis = list(title = input$oilPerform))
  })

  # Draw the oil heatmap
  output$oilHeatmap <- plotly::renderPlotly({
    oil_num <- subset(oil, select = c("Revenue", "Bill", "Year"))
    dfcor <- cor(oil_num, use = "complete.obs")
    dfvar <- dfcor ^ 2 * 100
    if (input$oilSensitivity == "varr") {
      df <- dfvar
    } else {
      df <- dfcor
    }
    plotly::plot_ly(
      x = c("Revenue", "Bill", "Year"),
      y = c("Revenue", "Bill", "Year"),
      z = df,
      colorscale = "Greys",
      type = "heatmap"
    )
  })

  # Plot the oil explorer motion chart
  output$oilMotion <- googleVis::renderGvis({
    googleVis::gvisMotionChart(oilMotionData, idvar = "Company", timevar = "Year")
  })
})

app <- ShinyDriver$new("../", seed = 123, loadTimeout = 1e+05)
app$snapshotInit("mytest")

Sys.sleep(2)
app$setInputs(sidebarItemExpanded = "Electric")
Sys.sleep(2)
app$setInputs(sidebarItemExpanded = "Hydropower")
# Input 'map1_groups' was set, but doesn't have an input binding.
# Input 'hydroTable_rows_current' was set, but doesn't have an input binding.
# Input 'hydroTable_rows_all' was set, but doesn't have an input binding.
Sys.sleep(2)
app$setInputs(sidebarItemExpanded = "NaturalGas")
# Input 'map2_groups' was set, but doesn't have an input binding.
# Input 'map3_groups' was set, but doesn't have an input binding.
# Input 'pipelineTable_rows_current' was set, but doesn't have an input binding.
# Input 'pipelineTable_rows_all' was set, but doesn't have an input binding.
Sys.sleep(2)
app$setInputs(sidebarItemExpanded = "Oil")
app$snapshot()

# Dashboard page
shinydashboard::dashboardPage(

  # Dashboard header
  shinydashboard::dashboardHeader(title = "eAnalytics"),

  # Dashboard sidebar
  shinydashboard::dashboardSidebar(

    # Sidebar menu
    shinydashboard::sidebarMenu(

      # Home menu item
      shinydashboard::menuItem("Home",
                               tabName = "home",
                               icon = shiny::icon("home")),

      # Electric menu item
      shinydashboard::menuItem(
        "Electric",
        icon = shiny::icon("bolt"),
        tabName = "electric",

        # Electric trends menu sub-item
        shinydashboard::menuSubItem(
          "Trends",
          tabName = "elecTrends",
          icon = shiny::icon("line-chart")
        ),

        # Electric performance menu sub-item
        shinydashboard::menuSubItem(
          "Performance",
          tabName = "elecPerform",
          icon = shiny::icon("bar-chart")
        ),

        # Electric explorer menu sub-item
        shinydashboard::menuSubItem(
          "Explorer",
          tabName = "elecExplorer",
          icon = shiny::icon("gear")
        ),

        # Electric data menu sub-item
        shinydashboard::menuSubItem(
          "Data",
          tabName = "elecData",
          icon = shiny::icon("table"))
      ),

      # Hydropower menu item
      shinydashboard::menuItem(
        "Hydropower",
        icon = shiny::icon("tint"),
        tabName = "hydroelectric",

        # Hydropower profile menu sub-item
        shinydashboard::menuSubItem(
          "Profile",
          tabName = "hydroProfile",
          icon = shiny::icon("globe")
        ),

        # Hydropower data menu sub-item
        shinydashboard::menuSubItem(
          "Data",
          tabName = "hydroData",
          icon = shiny::icon("table"))
      ),

      # Natural gas menu item
      shinydashboard::menuItem(
        "Natural Gas",
        icon = shiny::icon("fire"),
        tabName = "naturalgas",

        # Natural gas profile menu sub-item
        shinydashboard::menuSubItem(
          "Profile",
          tabName = "gasProfile",
          icon = shiny::icon("globe")
        ),

        # Natural gas performance menu sub-item
        shinydashboard::menuSubItem(
          "Performance",
          tabName = "gasPerform",
          icon = shiny::icon("bar-chart")
        ),

        # Natural gas trends menu sub-item
        shinydashboard::menuSubItem(
          "Trends",
          tabName = "gasTrends",
          icon = shiny::icon("line-chart")
        ),

        # Natural gas explorer menu sub-item
        shinydashboard::menuSubItem(
          "Explorer",
          tabName = "gasExplorer",
          icon = shiny::icon("gear")
        ),

        # Natural gas data menu sub-item
        shinydashboard::menuSubItem(
          "Data",
          tabName = "gasData",
          icon = shiny::icon("table"))
      ),

      # Oil menu item
      shinydashboard::menuItem(
        "Oil",
        icon = shiny::icon("flask"),
        tabName = "oil",

        # Oil trends menu sub-item
        shinydashboard::menuSubItem(
          "Trends",
          tabName = "oilTrends",
          icon = shiny::icon("line-chart")
        ),

        # Oil performance menu sub-item
        shinydashboard::menuSubItem(
          "Performance",
          tabName = "oilPerform",
          icon = shiny::icon("bar-chart")
        ),

        # Oil explorer menu sub-item
        shinydashboard::menuSubItem(
          "Explorer",
          tabName = "oilExplorer",
          icon = shiny::icon("gear")
        ),

        # Oil data menu sub-item
        shinydashboard::menuSubItem(
          "Data",
          tabName = "oilData",
          icon = shiny::icon("table"))
      ),
      br(),

      # Help menu item
      shinydashboard::menuItem("Help",
                               icon = icon("info-circle"),
                               href = "http://paulgovan.github.io/eAnalytics/"),

      # Source code menu item
      shinydashboard::menuItem("Source Code",
                               icon = icon("code"),
                               href = "https://github.com/paulgovan/eAnalytics")
    )
  ),

  # Dashboard body
  shinydashboard::dashboardBody(

    # Dashboard favicon and title
    tags$head(
      tags$link(rel = "icon", type = "image/png", href = "favicon.png"),
      tags$title("eAnalytics")
    ),

    # Dashboard tab items
    shinydashboard::tabItems(

      # Home tab item
      shinydashboard::tabItem(
        tabName = "home",
        shiny::fluidRow(

          # Welcome box
          shinydashboard::box(
            title = "",
            status = "primary",
            width = 8,
            shiny::img(
              src = "favicon.png",
              height = 200,
              width = 175
            ),
            shiny::h2("eAnalytics"),
            shiny::h4("Dynamic Web-based Analytics for the Energy Industry"),
            br(),
            shiny::h4(
              "eAnalytics is a ",
              shiny::a(href = 'http://shiny.rstudio.com', 'Shiny'),
              "web application built on top of R for energy-related data analytics"
            ),
            shiny::h4(
              "eAnalytics has the largest open database of US energy industry information, providing interactive web-based analytics to industry stakeholders."
            ),
            shiny::h4("To get started, select an industry in the sidepanel."),
            br(),
          ),

          # Projects, companies, and facilities value boxes
          shiny::uiOutput("projectBox"),
          shiny::uiOutput("companyBox"),
          shiny::uiOutput("facilityBox")
        ),
        shiny::fluidRow(
          shinydashboard::box(
            title = "Companies by Industry",
            status = "primary",
            width = 12,
            collapsible = TRUE,
            plotly::plotlyOutput("homeChart")
          )
        )
      ),

      # Electric trends tab item
      shinydashboard::tabItem(
        tabName = "elecTrends",
        shiny::fluidRow(

          # Electric trends box
          shinydashboard::box(

            title = "Revenue Trends",
            status = "primary",
            width = 12,
            collapsible = T,

            # Electric rates line chart
            plotly::plotlyOutput("lineChart1"),

            shinyWidgets::dropdownButton(

              # Panel title
              shiny::h4("List of Inputs"),

              # Electric rates input select
              shiny::selectInput(
                "elec",
                h5("Select Input:"),
                c("Revenue (USD)" =
                    "Revenue",
                  "Bill (USD)" = "Bill")
              ),

              # Company filter
              shiny::selectizeInput(
                "elecCompany",
                h5("Filter Companies:"),
                choices = NULL,
                multiple = TRUE,
                options = list(placeholder = "All companies")
              ),
              circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
              tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
              up = TRUE
            )
          )
        )
      ),

      # Electric performance tab item
      shinydashboard::tabItem(
        tabName = "elecPerform",
        shiny::fluidRow(

          # Electric performance histogram box
          shinydashboard::box(
            title = "Performance Indicator",
            status = "primary",
            width = 6,
            collapsible = TRUE,
            plotly::plotlyOutput("elecHist")
          ),

          # Electric heatmap box
          shinydashboard::box(
            title = "Heatmap",
            status = "primary",
            width = 6,
            collapsible = TRUE,
            plotly::plotlyOutput("elecHeatmap")
          )
        ),
        shiny::fluidRow(
          shinyWidgets::dropdownButton(
            shiny::h4("List of Inputs"),
            shiny::selectInput(
              "elecPerform",
              h5("Select Performance Indicator:"),
              c("Revenue Distribution" = "Revenue",
                "Bill Distribution" = "Bill")
            ),
            shiny::selectInput(
              "elecSensitivity",
              h5("Select Type of Sensitivity Measure:"),
              c("Contribution to Variance" = "varr",
                "Rank Correlation" = "corr")
            ),
            circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
            tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
            up = TRUE
          )
        )
      ),

      # Electric explorer tab item
      shinydashboard::tabItem(
        tabName = "elecExplorer",
        shinydashboard::box(
          title = "Explorer",
          status = "primary",
          width = 12,
          collapsible = TRUE,
          shiny::htmlOutput("elecMotion"),
          style = "overflow:hidden;"
        )
      ),

      # Electric data tab item
      shinydashboard::tabItem(
        tabName = "elecData",

        # Electric rates data box
        shinydashboard::box(
          title = "Revenue Data",
          status = "primary",
          width = 12,
          collapsible = T,

          # Electric rates data table
          DT::dataTableOutput("elecTable")
        )
      ),

      # Hydropower profile tab item
      shinydashboard::tabItem(
        tabName = "hydroProfile",

        # Hydropower profile tab panel
        shiny::tabPanel(
          "Hydropower Facilities",

          # Hydropower profile map
          leaflet::leafletOutput("map1"),
          # tags$style(type = "text/css", "#map1 {height: calc(100vh - 80px) !important;}"),

          # Hydropower panel
          shinyWidgets::dropdownButton(

            # Panel title
            shiny::h4("List of Inputs"),

            # Marker size input select
            shiny::selectInput("hydroSize", h5("Marker Size:"),
                               c("Total Capacity (MW)" = "Total")),

            # Marker color input select
            shiny::selectInput("hydroCol", h5("Marker Color:"),
                               c("Status" = "status")),

            circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
            tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
            up = TRUE
          )
        )
      ),

      # Hydropower data tab item
      shinydashboard::tabItem(
        tabName = "hydroData",

        # Hydropower data box
        shinydashboard::box(
          title = "Hydropower Facility Data",
          status = "primary",
          width = 12,
          collapsible = T,

          # Hydropower data table
          DT::dataTableOutput("hydroTable")
        )
      ),

      # Natural gas profile tab item
      shinydashboard::tabItem(
        tabName = "gasProfile",

        # Natural gas storage facilities tab box
        shinydashboard::tabBox(
          width = 12,

          # Natural gas storage facilities tab panel
          shiny::tabPanel(
            "Storage Facilities",

            # Storage facilities map
            leaflet::leafletOutput("map2"),
            # tags$style(type = "text/css", "#map2 {height: calc(100vh - 80px) !important;}"),

            shinyWidgets::dropdownButton(

                # Panel title
                shiny::h4("List of Inputs"),

                # Marker size input select
                shiny::selectInput(
                  "storageSize",
                  h5("Marker Size:"),
                  c("Total Capacity (BCF)" = "Total",
                    "Working Capacity (BCF)" = "Working"
                  )
                ),

                # Marker color input select
                shiny::selectInput("storageColor", h5("Marker Color:"),
                                   c("Storage Type" =
                                       "type")),
                circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
                tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
                up = TRUE
            )
          ),

          # LNG facilities tab panel
          shiny::tabPanel(
            "LNG Facilities",

            # LNG facilities map
            leaflet::leafletOutput("map3"),
            # tags$style(type = "text/css", "#map3 {height: calc(100vh - 80px) !important;}"),

            shinyWidgets::dropdownButton(

              # Panel title
                shiny::h4("List of Inputs"),

                # Marker size input select
                shiny::selectInput("lngSize", h5("Marker Size:"),
                                   c("Total Capacity (BCFD)" = "Total")),

                # Marker color input select
                shiny::selectInput("lngColor", h5("Marker Color:"),
                                   c("Facility Type" = "type",
                                     "Status" = "status")
                ),
                circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
                tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
                up = TRUE
            )
          )
        )
      ),

      # Natural gas performance tab item
      shinydashboard::tabItem(
        tabName = "gasPerform",
        shiny::fluidRow(

          # Natural gas performance box
          shinydashboard::box(
            title = "Performance Indicator",
            status = "primary",
            width = 6,
            collapsible = T,

            # Natural gas performance histogram
            plotly::plotlyOutput("hist5")
          ),

          # Natural gas heatmap box
          shinydashboard::box(
            title = "Heatmap",
            status = "primary",
            width = 6,
            collapsible = T,

            # Natural gas heatmap
            plotly::plotlyOutput("heatmap")
          )
        ),
        shiny::fluidRow(

          shinyWidgets::dropdownButton(

            # Panel title
            shiny::h4("List of Inputs"),

            # Performance variable input select
            shiny::selectInput(
              "perform",
              h5("Select Performance Indicator:"),
              c(
                "Cost/Mile (kUSD/Mile)" = "costMile",
                "Cost/Added Capacity (kUSD/MMcf/d)" = "costCap"
              )
            ),

            # Heatmap type input select
            shiny::selectInput(
              "sensitivity",
              h5("Select Type of Sensitivity Measure:"),
              c(
                "Contribution to Variance" = "varr",
                "Rank Correlation" = "corr"
              )
            ),
            circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
            tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs !"),
            up = TRUE
          )
        )
      ),

      # Natural gas trends tab item
      shinydashboard::tabItem(
        tabName = "gasTrends",

        # Natural gas trends tab box
        shinydashboard::tabBox(
          width = 12,

          # Natural gas cost trends tab panel
          shiny::tabPanel(
            "Cost Trends",
            shiny::fluidRow(

              # Natural gas cost trends box
              shinydashboard::box(
                title = "Project Cost Trends",
                status = "primary",
                width = 12,
                collapsible = T,

                # Natural gas cost trends box plots
                plotly::plotlyOutput("boxplot"),

                shinyWidgets::dropdownButton(

                  # Panel title
                  shiny::h4("List of Inputs"),

                  # Cost variable input select
                  shiny::selectInput(
                    "gas",
                    h5("Select Input:"),
                    c("Cost (mUSD)" = "cost",
                      "Cost/Mile (mUSD/Mile)" = "costMile")
                  ),
                  circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
                  tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
                  up = TRUE
                )
              )
            )
          ),

          # Natural gas revenue trends tab panel
          shiny::tabPanel(
            "Revenue Trends",
            fluidRow(

              # Natural gas revenue trends box
              shinydashboard::box(
                title = "Revenue Trends",
                status = "primary",
                width = 12,
                collapsible = T,

                # Natural gas revenue line chart
                plotly::plotlyOutput("lineChart3"),

                shinyWidgets::dropdownButton(

                  # Panel title
                  shiny::h4("List of Inputs"),

                  # Revenue variable input select
                  shiny::selectInput(
                    "gasRates",
                    h5("Select Input:"),
                    c("Revenue (USD)" = "Revenue",
                      "Bill (USD)" = "Bill")
                  ),

                  # Company filter
                  shiny::selectizeInput(
                    "gasCompany",
                    h5("Filter Companies:"),
                    choices = NULL,
                    multiple = TRUE,
                    options = list(placeholder = "All companies")
                  ),
                  circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
                  tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
                  up = TRUE
                )
              )
            )
          )
        )
      ),

        # Natural gas explorer tab item
        shinydashboard::tabItem(
          tabName = "gasExplorer",

          # Natural gas explorer box
          shinydashboard::box(
            title = "Explorer",
            status = "primary",
            width = 12,
            collapsible = T,

            # Natural gas googleVis motion chart
            shiny::htmlOutput("motion1"),
            style = "overflow:hidden;"
          )
        ),

        # Natural gas data tab item
        shinydashboard::tabItem(
          tabName = "gasData",

          # Natural gas data tab box
          shinydashboard::tabBox(
            width = 12,

            # Natural gas project data tab panel
            shiny::tabPanel("Project Data",
                            DT::dataTableOutput("pipelineTable")),

            # Natural gas revenue data tab panel
            shiny::tabPanel("Revenue Data",
                            DT::dataTableOutput("gasTable"))
          )
        ),

        # Oil trends tab item
        shinydashboard::tabItem(
          tabName = "oilTrends",
          shiny::fluidRow(

            # Oil trends box
            shinydashboard::box(
              title = "Revenue Trends",
              status = "primary",
              width = 12,
              collapsible = T,

              # Oil trends line chart
              plotly::plotlyOutput("lineChart4"),

              shinyWidgets::dropdownButton(

                # Panel title
                shiny::h4("List of Inputs"),

                # Rates variable input select
                shiny::selectInput(
                  "oil",
                  h5("Select Input:"),
                  c("Revenue (USD)" = "Revenue",
                    "Bill (USD)" = "Bill")
                ),

                # Company filter
                shiny::selectizeInput(
                  "oilCompany",
                  h5("Filter Companies:"),
                  choices = NULL,
                  multiple = TRUE,
                  options = list(placeholder = "All companies")
                ),
                circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
                tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
                up = TRUE
              )
            )
          )
        ),

        # Oil performance tab item
        shinydashboard::tabItem(
          tabName = "oilPerform",
          shiny::fluidRow(

            # Oil performance histogram box
            shinydashboard::box(
              title = "Performance Indicator",
              status = "primary",
              width = 6,
              collapsible = TRUE,
              plotly::plotlyOutput("oilHist")
            ),

            # Oil heatmap box
            shinydashboard::box(
              title = "Heatmap",
              status = "primary",
              width = 6,
              collapsible = TRUE,
              plotly::plotlyOutput("oilHeatmap")
            )
          ),
          shiny::fluidRow(
            shinyWidgets::dropdownButton(
              shiny::h4("List of Inputs"),
              shiny::selectInput(
                "oilPerform",
                h5("Select Performance Indicator:"),
                c("Revenue Distribution" = "Revenue",
                  "Bill Distribution" = "Bill")
              ),
              shiny::selectInput(
                "oilSensitivity",
                h5("Select Type of Sensitivity Measure:"),
                c("Contribution to Variance" = "varr",
                  "Rank Correlation" = "corr")
              ),
              circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
              tooltip = shinyWidgets::tooltipOptions(title = "Click to see inputs"),
              up = TRUE
            )
          )
        ),

        # Oil explorer tab item
        shinydashboard::tabItem(
          tabName = "oilExplorer",
          shinydashboard::box(
            title = "Explorer",
            status = "primary",
            width = 12,
            collapsible = TRUE,
            shiny::htmlOutput("oilMotion"),
            style = "overflow:hidden;"
          )
        ),

        # Oil data tab item
        shinydashboard::tabItem(
          tabName = "oilData",

          # Oil data box
          shinydashboard::box(
            title = "Revenue Data",
            status = "primary",
            width = 12,
            collapsible = T,

            # Oil data table
            DT::dataTableOutput("oilTable")
          )
        )
      )
    )
  )

#This script is necessary in the app folder
#but the user should not have to edit it

#Output Graph Function
graphOutput <- function(inputId, width="100%", height="550px") {
  tagList(
    singleton(tags$head(
      tags$script(src="plotlyGraphWidget.js")
    )),
    tags$iframe(id=inputId, src="https://plot.ly/~playground/7.embed",
                class="graphs", style="border:none;", seamless=TRUE, width=width, height=height)
  )
}

renderGraph <- function(expr, env=parent.frame(), quoted=FALSE) {
  ## This gets called when inputs change --
  ## Place data wrangling code in here
  ## and pass the result to the client
  ## to be graphed.


  installExprFunction(expr, "func", env, quoted)

  function(){
    data = func();
    ## data is the state of the widgets: see server.R
    ## this function returns a list of named lists that descripe
    ## valid postMessage commands to be sent to the embedded iframe.
    ## see binding.renderValue for the receiving JS side of this function
    ## and https://github.com/plotly/Embed-API for more about the postMessage
    ## graph messages
    return(data)

  }
}

#' Launch eAnalytics Shiny Application
#'
#' This function launches the eAnalytics Shiny application, which provides
#' interactive visualizations and analyses of energy data. The application
#' includes features such as time series plots, motion charts, data tables,
#' and geographic maps.
#'
#' @seealso \url{http://paulgovan.github.io/eAnalytics/}
#' @examples
#' if (interactive()) {
#'   eAnalytics()
#' }
#' @return The function does not return a value; it launches the Shiny app.
#' @importFrom plotly as.widget renderPlotly plot_ly plotlyOutput "%>%"
#' @importFrom dplyr select filter
#' @importFrom DT dataTableOutput renderDataTable datatable formatCurrency "%>%"
#' @import energyr
#' @importFrom googleVis renderGvis gvisMotionChart
#' @importFrom leaflet renderLeaflet colorFactor leaflet fitBounds
#'   addProviderTiles addCircles addLegend addLayersControl layersControlOptions
#'   leafletOutput "%>%"
#' @importFrom shiny shinyServer renderUI icon fluidRow img a uiOutput
#'   absolutePanel wellPanel selectInput
#' @importFrom shinydashboard dashboardPage dashboardHeader dropdownMenu
#'   messageItem dashboardSidebar sidebarMenu menuItem menuSubItem dashboardBody
#'   tabItems tabItem box tabBox
#' @importFrom shinyWidgets dropdownButton tooltipOptions
#' @export
eAnalytics <- function() {
  shiny::runApp(system.file("app", package = "eAnalytics"))
}

---
title: "Getting Started"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Usage}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## Home
Launching the app first brings up the Home tab, which is basically a landing page that gives a brief introduction to the app and includes three value boxes for the current number of projects, companies, and facilities in the database. 

![](https://github.com/paulgovan/eAnalytics/blob/master/inst/images/Dashboard.png?raw=true)

## Profile
The Profile tab contains a number of interactive maps with information about facilities for the selected industry. The figure below shows the Profile tab for the Natural Gas Industry.

Multiple options are currently available for customizing the maps. Choose a preferred size or color variable in the movable well panel, select from different basemaps via the lower-right control, and click on a specific facility to view additional information.

![](https://github.com/paulgovan/eAnalytics/blob/master/inst/images/Profile2.png?raw=true)

## Performance
The Performance tab tracks a number of Key Performance Indicators (KPIs) for the selected industry. The following figure shows the Performance tab for the Natural Gas Industry.

![](https://github.com/paulgovan/eAnalytics/blob/master/inst/images/Performance2.png?raw=true) 

## Trends

The Trends tab contains multiple interactive time-series charts of financial information for the selected industry. The following figure shows the Performance tab for the Electric industry.

The time-series chart in the Trends tab is linked to the data table shown in the Data tab. Searching, filtering, and sorting the data in the data table will automatically update the time-series chart with the selected data.

![](https://github.com/paulgovan/eAnalytics/blob/master/inst/images/Trends2.png?raw=true)

## Data 
The Data tab contains interactive datatables of information for the selected industry. The data can be searched, filtered, and sorted as required. The selected data can then be copied to the clipboard, downloaded to a csv or pdf file, or sent to a local printer. The figure below shows the Data tab for the Hydropower industry.

![](https://github.com/paulgovan/eAnalytics/blob/master/inst/images/Data.png?raw=true)

## Explorer
The Explorer tab contains a dynamic motion chart for exploring several indicators over time. The following figure shows the Explorer tab for the Natural Gas Industry.

![](https://github.com/paulgovan/eAnalytics/blob/master/inst/images/Explorer2.png?raw=true)

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eAnalytics.R
\name{eAnalytics}
\alias{eAnalytics}
\title{Launch eAnalytics Shiny Application}
\usage{
eAnalytics()
}
\value{
The function does not return a value; it launches the Shiny app.
}
\description{
This function launches the eAnalytics Shiny application, which provides
interactive visualizations and analyses of energy data. The application
includes features such as time series plots, motion charts, data tables,
and geographic maps.
}
\examples{
if (interactive()) {
  eAnalytics()
}
}
\seealso{
\url{http://paulgovan.github.io/eAnalytics/}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eAnalytics-package.R
\docType{package}
\name{eAnalytics-package}
\alias{eAnalytics-package}
\title{eAnalytics: Dynamic Web-Based Analytics for the Energy Industry}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

A 'Shiny' web application for energy industry analytics. Take an overview of the industry, measure Key Performance Indicators, identify changes in the industry over time, and discover new relationships in the data.
}
\seealso{
Useful links:
\itemize{
  \item \url{http://paulgovan.github.io/eAnalytics/}
  \item \url{https://github.com/paulgovan/eAnalytics}
  \item Report bugs at \url{https://github.com/paulgovan/eAnalytics/issues}
}

}
\author{
\strong{Maintainer}: Paul Govan \email{paul.govan2@gmail.com} (\href{https://orcid.org/0000-0002-1821-8492}{ORCID}) [copyright holder]

}
\keyword{internal}
